import QtQuick 1.0
import Places 1.0
import "util.js" as Util
import com.nokia.meego 1.0
//import Qt.labs.components 1.0

Page {
    id: settingspage
    anchors.fill: parent

    Rectangle {
        id: aboutpageheader;
        anchors.left: parent.left;
        anchors.right: parent.right;
        anchors.top: parent.top;
        height: commonToolBar.height

        Image {
            id: header_bg;
            source: "qrc:/res/header_meego.png"
            anchors.left: parent.left;
            anchors.right: parent.right;
            anchors.top: parent.top;
            anchors.bottom: parent.bottom;
            anchors.leftMargin: -1
            anchors.rightMargin: -1
            sourceSize.width: 480
            sourceSize.height: 80
            smooth: false
        }

        Text {
            id: about_title
            font.pixelSize: 32
            text: qsTr("About")
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter
            color: "white"
            font.weight: Font.Light
            elide: Text.ElideRight
            wrapMode: Text.NoWrap
        }
    }

    Rectangle {
        id: aboutRect
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: aboutpageheader.bottom
        anchors.bottom: parent.bottom
        gradient: Gradient {
            GradientStop {
                position: 0
                color: "#394A66"
            }
            GradientStop {
                position: 0.5
                color: "#202C3C"
            }
            GradientStop {
                position: 1
                color: "#05090F"
            }
        }
    }

    Image {
        id: aboutImage
        source: "qrc:/res/logo_about.png"
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: aboutpageheader.bottom
        anchors.topMargin: (parent.width > parent.height) ? 13 : 90
        smooth: true
    }

    Text {
        id: version_text
        font.pixelSize: 24
        text: qsTr("version")
        horizontalAlignment: Text.AlignHCenter
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: aboutImage.bottom
        anchors.topMargin: (parent.width > parent.height) ? 11 : 60
        color: "white"
        font.weight: Font.Light
        elide: Text.ElideRight
        wrapMode: Text.NoWrap
    }

    Text {
        id: vendor_text1
        font.pixelSize: 28
        text: qsTr("vendor_en")
        anchors.left: parent.left
        anchors.leftMargin: (parent.width < parent.height) ? (parent.width - width) / 2 : (parent.width - width - vendor_split.width - vendor_text2.width) / 2
        anchors.top: version_text.bottom
        anchors.topMargin: (parent.width > parent.height) ? 13 : 33
        color: "white"
        font.weight: Font.Light
        elide: Text.ElideRight
        wrapMode: Text.NoWrap
    }

    Text {
        id: vendor_split
        font.pixelSize: 28
        text: " / "
        visible: (parent.width > parent.height)
        anchors.left: vendor_text1.right
        anchors.top: version_text.bottom
        anchors.topMargin: (parent.width > parent.height) ? 13 : 33
        color: "white"
        font.weight: Font.Light
        elide: Text.ElideRight
        wrapMode: Text.NoWrap
    }

    Text {
        id: vendor_text2
        font.pixelSize: 28
        text: (parent.width > parent.height) ? "" : qsTr("vendor_ru")
        anchors.left: (parent.width < parent.height) ? parent.left : vendor_split.right
        anchors.leftMargin: (parent.width < parent.height) ? (parent.width - width) / 2 : 0
        anchors.top: (parent.width < parent.height) ? vendor_text1.bottom : version_text.bottom
        anchors.topMargin: (parent.width < parent.height) ? 7 : 13
        color: "white"
        font.weight: Font.Light
        elide: Text.ElideRight
        wrapMode: Text.NoWrap
    }

    Text {
        id: support_text
        font.pixelSize: 21
        text: "support@gismeteo.ru"
        horizontalAlignment: Text.AlignHCenter
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.bottom: parent.bottom
        anchors.bottomMargin: (parent.width > parent.height) ? 77 : 133
        color: "#859CBA"
        font.weight: Font.Light
        elide: Text.ElideRight
        wrapMode: Text.NoWrap
    }

    onStatusChanged: {
        if (status === PageStatus.Active) {
            about_title.text = qsTr("About");
            version_text.text = qsTr("version");
            vendor_text1.text = qsTr("vendor_en")
            vendor_text2.text = qsTr("vendor_ru");
        };
    }
}
