import QtQuick 1.0
import Places 1.0
import "util.js" as Util

Rectangle {
    id: listContainerRect
    width: (((factory.landscape) || (mainPage.height < mainPage.width)) ? (isLastItem ? (5 * mainPage.width / 6) : mainPage.width / 6) : (isLastItem ? (3 * mainPage.width) / 4 : mainPage.width / 4))
    height: fcList.height
        gradient: Gradient {
            GradientStop {
                position: 0
                color: "#374A68"
            }
            GradientStop {
                position: 0.82
                color: "#05080D"
            }
            GradientStop {
                position: 1
                color: "#05080D"
            }
        }

    function fOpacity (pos) {
        var res = 0;
        res = (((((0.047 * pos)/1000 - 0.11) * pos)/1000 - 0.137)*pos)/1000 + 0.84;
        return res;
    }

    MouseArea {
        anchors.fill: parent
        onClicked: {
            var pos = fcList.contentX;
            var destPos;
            fcList.currentIndex = index;
            Util.currentForecastIndx = fcList.currentIndex;
            fcList.positionViewAtIndex(index, ListView.Beginning);
            destPos = fcList.contentX;
            anim.from = pos;
            anim.to = destPos;
            anim.running = true;
            factory.updateListIndex(forecastIndex);
        }
    }

    Image {
        id: select
        smooth: true
        opacity: 0.95
        //opacity: fOpacity(((index*listContainerRect.width - fcList.contentX) * 1000) / listContainerRect.width)
        visible: (mainPage.height > mainPage.width) && (fcList.currentIndex == index)
        source: "qrc:/res/select.png"
        //anchors.verticalCenter: parent.verticalCenter
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.leftMargin: (parent.width - width) / 2
        sourceSize.width: 50
        sourceSize.height: 26
        height: (5*Util.forecastMargin)/2
        width: (height*sourceSize.width)/sourceSize.height
    }

    Text {
        id: dateText
        anchors.top: parent.top
        anchors.topMargin: (!(factory.landscape) || (mainPage.height > mainPage.width)) ? 3*Util.forecastMargin : (3*Util.forecastMargin)/4
        font.pixelSize: Util.forecastFontSize
        anchors.horizontalCenter: parent.horizontalCenter
        color: "#FFFFFF"
        horizontalAlignment: Text.AlignHCenter
        text: forecast.dateDescription(true)
    }

    Text {
        id: tText
        anchors.top: dateText.bottom
        anchors.topMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/2 : Util.forecastMargin
        anchors.bottomMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin : Util.forecastMargin*2
        anchors.horizontalCenter: parent.horizontalCenter
        color: "#FFFFFF"
        font.pixelSize: Util.minfontSize
        horizontalAlignment: Text.AlignHCenter
        text: forecast.temperatureDescription(factory.t === GismeteoFactory.Fahrenheit)
    }

    Image {
        id: starimage
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: tText.bottom
        anchors.topMargin: (mainPage.height < mainPage.width) ? 0 : 0 //Util.forecastMargin/4
        anchors.bottomMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin : (Util.forecastMargin*7)/4
        width: (mainPage.height < mainPage.width) ? parent.width - 6*Util.forecastMargin : parent.width - Util.forecastMargin
        height: (mainPage.height < mainPage.width) ? parent.width - 6*Util.forecastMargin : parent.width - Util.forecastMargin
        sourceSize.height: 240
        sourceSize.width: 240
        smooth: true
        source: (forecast === undefined) ? "" : "image://weather/" + forecast.iconDescription
    }

    Text {
        id: description
        anchors.top: starimage.bottom
        anchors.topMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/2 : Util.forecastMargin
        anchors.horizontalCenter: parent.horizontalCenter
        color: "#859CBA"
        font.pixelSize: Util.forecastFontSize
        font.weight: Font.Light
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignTop //Text.AlignVCenter
        anchors.leftMargin: Util.forecastMargin
        anchors.rightMargin: Util.forecastMargin
        width: listContainerRect.width - 2*Util.forecastMargin
        wrapMode: Text.WordWrap
    }

    Text {
        id: humText
        visible: mainPage.height < mainPage.width
        anchors.top: description.bottom
        anchors.topMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.bottomMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.left: parent.left
        anchors.leftMargin: (parent.width - width - humText_part2.width)/2
        color: "#FFFFFF"
        font.pixelSize: Util.forecastFontSize+1
        font.weight: Font.Light
        horizontalAlignment: Text.AlignHCenter
        text: (forecast === undefined) ? "" : forecast.minHumidity + "% "
    }

    Text {
        id: humText_part2
        visible: mainPage.height < mainPage.width
        anchors.top: description.bottom
        anchors.topMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.bottomMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.left: humText.right
        color: "#859CBA"
        font.pixelSize: Util.forecastFontSize+1
        font.weight: Font.Light
        horizontalAlignment: Text.AlignHCenter
        text: (forecast === undefined) ? "" : Util.humidityText100()
    }

    Text {
        id: pText
        visible: mainPage.height < mainPage.width
        anchors.top: humText.bottom
        anchors.topMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.bottomMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.left: parent.left
        anchors.leftMargin: (parent.width - width - pText_part2.width)/2
        color: "#FFFFFF"
        font.pixelSize: Util.forecastFontSize+1
        font.weight: Font.Light
        horizontalAlignment: Text.AlignHCenter
        text: (forecast === undefined) ? "" : ((factory.p === GismeteoFactory.MmHgSt) ? forecast.pressure + " " : Math.round((forecast.pressure*1000)/760) + " ")
    }

    Text {
        id: pText_part2
        visible: mainPage.height < mainPage.width
        anchors.top: humText.bottom
        anchors.topMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.bottomMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.left: pText.right
        color: "#859CBA"
        font.pixelSize: Util.forecastFontSize+1
        font.weight: Font.Light
        horizontalAlignment: Text.AlignHCenter
        text: (forecast === undefined) ? "" : ((factory.p === GismeteoFactory.MmHgSt) ? Util.mmhgText() : Util.gpaText())
    }

    Text {
        id: wsText
        visible: mainPage.height < mainPage.width
        anchors.top: pText.bottom
        anchors.topMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.bottomMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.left: parent.left
        anchors.leftMargin: (parent.width - width - wsText_part2.width)/2 - (Util.minfontSize/2 + windicon.width - 2)/2
        color: (forecast === undefined) || (forecast.windSpeed === 0) || (forecast.windDirection === Forecast.Calm) ? "#859CBA" : "#FFFFFF"
        font.pixelSize: Util.forecastFontSize+1
        font.weight: Font.Light
        horizontalAlignment: Text.AlignHCenter
        text: (forecast === undefined) ? "" : ((forecast.windSpeed === 0 || forecast.windDirection === Forecast.Calm) ? Util.getWindDirection(Forecast.Calm) : ((factory.ws === GismeteoFactory.Mps) ? forecast.windSpeed + ' ' : Math.round((forecast.windSpeed*36)/10) + ' '))
    }

    Text {
        id: wsText_part2
        visible: mainPage.height < mainPage.width
        anchors.top: pText.bottom
        anchors.topMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.bottomMargin: (mainPage.height < mainPage.width) ? Util.forecastMargin/4 : Util.forecastMargin/2
        anchors.left: wsText.right
        color: "#859CBA"
        font.pixelSize: Util.forecastFontSize+1
        font.weight: Font.Light
        horizontalAlignment: Text.AlignHCenter
        text: (forecast === undefined) ? "" : ((forecast.windSpeed === 0 || forecast.windDirection === Forecast.Calm) ? "" : ((factory.ws === GismeteoFactory.Mps) ? Util.mpsText() + ', ' + Util.getWindDirection(forecast.windDirection) : Util.kmhText() + ', ' + Util.getWindDirection(forecast.windDirection)))
    }

    Image {
        id: windicon
        visible: ((mainPage.height < mainPage.width) && (forecast.windDirection !== Forecast.Calm) && (forecast.windSpeed !== 0))
        rotation: (forecast.windDirection - 1)*45
        anchors.top: wsText_part2.top
        anchors.left: wsText_part2.right
        anchors.leftMargin: Util.minfontSize/2
        anchors.verticalCenter: wind.verticalCenter
        source: "qrc:/res/wind.png"
        width: Util.minfontSize
        height: Util.minfontSize
        smooth: true
    }

    NumberAnimation {
        id: anim
        target: fcList
        property: "contentX"
        duration: 300
    }

    Connections {
        target: factory

        onForecastsUpdated: {
        }
    }

    Component.onCompleted: {
        var itemwidth = (((factory.landscape) || (mainPage.height < mainPage.width)) ? mainPage.width / 5 : mainPage.width / 4);
        listContainerRect.width = (((factory.landscape) || (mainPage.height < mainPage.width)) ?
            (isLastItem ? (4*mainPage.width) / 5 : mainPage.width / 5) :
            (isLastItem ? (3*mainPage.width) / 4 : mainPage.width / 4));
        //listContainerRect.width = ((mainPage.height > mainPage.width) ? mainPage.width / 4 : mainPage.width / 6);
        if (Util.fcDescriptionRowHeight === 0) {
            description.text = "1\n1";
            Util.fcDescriptionRowHeight = description.height/2;
            description.text = " \n ";
        }
        if (forecast.description === undefined)
            return;
        description.text = forecast.description;
        var fWideText = true;
        description.font.pixelSize = Util.forecastFontSize - 4;
        while (fWideText) {
            while (description.height > (Util.fcDescriptionRowHeight*3*description.font.pixelSize)/Util.forecastFontSize) {
                var indx = description.text.lastIndexOf(",");
                if (indx !== -1) {
                    description.text = description.text.substring(0,indx);
                }
            };
            if (description.paintedWidth < listContainerRect.width - 2*Util.forecastMargin) {
                fWideText = false;
            } else {
                //if (description.font.pixelSize > Util.forecastFontSize - 3) {
                    description.font.pixelSize -= 1;
                //} else {
                //    description.text = "";
                //};
            };
        }
/*        if (description.paintedHeight < (Util.fcDescriptionRowHeight*2*description.font.pixelSize)/Util.forecastFontSize) {
            description.verticalAlignment = Text.AlignTop;
            description.anchors.topMargin = ((mainPage.height < mainPage.width) ? Util.forecastMargin/2 + 3 : Util.forecastMargin + 4);
            description.height = Util.fcDescriptionRowHeight*3 - ((mainPage.height < mainPage.width) ? 3 : 4);
        } else { */
            description.height = Util.fcDescriptionRowHeight*3;
//        };
        tText.color = (forecast.temperatureSign(factory.t === GismeteoFactory.Fahrenheit) === 1) ? "#FFFFFF" :
            ((forecast.temperatureSign(factory.t === GismeteoFactory.Fahrenheit) === -1) ? "#FFFFFF" : "#FFFFFF");
    }
}
