import QtQuick 1.0
import "util.js" as Util
//import com.nokia.symbian 1.0

Item {
    id: searchlistContainerRect
    width: searchList.width
    height: Util.minLocationHeight

    Rectangle {
        anchors.fill: parent
        opacity: ((searchList.currentIndex === index) && (location.id !== -1)) ? 0.75 : 0
        gradient: Gradient {
            GradientStop {
                position: 0
                color: (location.id !== -1) ? ((searchList.currentIndex === index) ? "#506B93" : "#101620") : "#101620"
            }
            GradientStop {
                position: 0.7
                color: ((searchList.currentIndex === index) && (location.id !== -1)) ? "#243248" : "#101620"
            }
            GradientStop {
                position: 1
                color: "#101620"
            }
        }
    }

    MouseArea {
        anchors.fill: parent
        onClicked: {
            if ((searchList.model.count > 0) && (location.id !== -1)) {
                var pos = searchList.contentY;
                var destPos;
                var fTooBigList = false;
                searchList.currentIndex = index;
                var fFound = false;
                var i=0;
                console.log("clicked...");
                for (; i < factory.locationsCount; i++) {
                    if (factory.locations[i].id === location.id) {
                        fFound = true;
                        break;
                    }
                }
                if (factory.locationsCount >= 5) {
                    fTooBigList = true;
                };
                if (!fFound) {
                    if (!fTooBigList) {
                        var m_locCount = factory.locationsCount;
                        factory.addLocation(location.id, location.name, location.name, location.district, location.country, factory.locationsCount + 1);
                        factory.addLocationToDB(location);
                        factory.currentLocation = m_locCount;
                        factory.networkUpdate = true;
                        factory.isUpdatingNow = true;
                        console.log("new location added (0)...");
                        //factory.parseLocationsFromNetwork(true);
                        factory.emitRefresh();
                    }
                } else {
                    if (!fTooBigList) factory.currentLocation = i;
                };
                //if (pageStack.depth == 2) {
                //    commonToolBar.tools = mainLayout;
                //};
                //commonToolBar.tools = mainLayout;
                if (fTooBigList) {
                    //commonToolBar.tools = backLayout;
                    searchinfobanner.text = Util.msg5places();
                    if (platform === "s3") {
                        searchinfobanner.timeout = 3000;
                        searchinfobanner.open();
                    } else {
                        searchList.visible = false;
                        searchinfobanner.visible = true;
                    }
                } else {
                    commonToolBar.tools = mainLayout;
                    pageStack.pop(pageStack.find(function(page) {
                                                     return page.isStartPage === true;
                                                 }));
                }
            }
        }
    }

/*    Image {
        id: starimage1
        //anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: parent.top
        anchors.margins: Util.forecastMargin
        width: parent.height - 2*Util.forecastMargin
        height: parent.height - 2*Util.forecastMargin
        sourceSize.height: 240
        sourceSize.width: 240
        smooth: true
        source: ""
    } */

    Text {
        id: locname1
        anchors.top: parent.top
        anchors.topMargin: Util.forecastMargin
        anchors.left: parent.left
        anchors.leftMargin: Util.forecastMargin
        anchors.right: locdistance1.left
        anchors.rightMargin: Util.forecastMargin
        color: "#FFFFFF"
        font.pixelSize: Util.locationFontSize
        horizontalAlignment: Text.AlignLeft
        verticalAlignment: Text.AlignVCenter
        elide: Text.ElideRight
        text: location.prefName
    }

    Text {
        id: locdistance1
        height: (parent.height*3)/5 - 2*Util.forecastMargin
        anchors.top: parent.top
        anchors.topMargin: Util.forecastMargin
        anchors.right: parent.right
        anchors.rightMargin: Util.forecastMargin
        color: "#859CBA"
        font.pixelSize: Util.minfontSize
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        visible: (searchList.showDistance) && (location.id !== -1)
        text: location.distance

    }

    Text {
        id: locdistrict1
        anchors.top: locname1.bottom
        anchors.left: parent.left
        anchors.leftMargin: Util.forecastMargin
        anchors.right: locdistance1.left
        anchors.rightMargin: Util.forecastMargin
        color: "#859CBA"
        font.pixelSize: Util.minfontSize - 2
        horizontalAlignment: Text.AlignLeft
        verticalAlignment: Text.AlignVCenter
        elide: Text.ElideRight
        text: (location.district === "") ? location.country : location.district
    }

    Text {
        id: loccountry1
        anchors.top: locdistrict1.bottom
        anchors.bottomMargin: Util.forecastMargin
        anchors.left: parent.left
        anchors.leftMargin: Util.forecastMargin
        anchors.right: locdistance1.left
        anchors.rightMargin: Util.forecastMargin
        color: "#859CBA"
        font.pixelSize: Util.minfontSize - 2
        horizontalAlignment: Text.AlignLeft
        verticalAlignment: Text.AlignVCenter
        elide: Text.ElideRight
        text: (location.district === "") ? "" : location.country
    }

    Rectangle {
        id: down_line
        opacity: 0.5
        visible: location.id !== -1
        anchors.bottom: parent.bottom
        height: 1
        anchors.left: parent.left
        anchors.leftMargin: (index === locList.currentIndex - 1) ? 0 : Util.forecastMargin
        anchors.right: parent.right
        anchors.rightMargin: (index === locList.currentIndex - 1) ? 0 : Util.forecastMargin
        color: "#506B93"
    }
}
