import QtQuick 1.0
import "util.js" as Util

Item {
    id: loclistContainerRect
    width: locList.width
    height: Util.minLocationHeight

    property bool mousePressed: false
    property int mouseTime: 0

    //visible: ((y >= ListView.view.contentY &&
    //    y <= ListView.view.contentY + ListView.view.contentHeight)  ||
    //    (y + height >= ListView.view.contentY &&
    //    y + height <= ListView.view.contentY + ListView.view.contentHeight))
    Rectangle {
        anchors.fill: parent
        opacity: ((locList.currentIndex === index) && (location.id !== -1)) ? 0.75 : 0
        gradient: Gradient {
            GradientStop {
                position: 0
                color: (location.id !== -1) ? ((locList.currentIndex === index) ? "#506B93" : "#101620") : "#101620"
            }
            GradientStop {
                position: 0.7
                color: ((locList.currentIndex === index) && (location.id !== -1)) ? "#243248" : "#101620"
            }
            GradientStop {
                position: 1
                color: "#101620"
            }
        }
    }

    Timer {
        id: screenRotateTimer_loc
        interval: 200
        repeat: true
        triggeredOnStart : false
        onTriggered: {
            //if (((root.width > parent.height) && (!factory.landscape)) ||
            //    ((root.width < parent.height) && (factory.landscape)))
            //{
                if (mousePressed) mouseTime += 200;
                locdistrict.text = (location.prefName === location.name) ? ((location.district === "") ? location.country : location.district) : location.name + ((location.district === "") ? ", " + location.country : ", " + location.district);
                locdistrict.font.pixelSize = Util.minfontSize - 2;
                var fWideText = (locdistrict.paintedWidth >= parent.width - starimage.width - tText.width - 4*Util.forecastMargin);
                while (fWideText) {
                    var indx = locdistrict.text.lastIndexOf(" ");
                    if (indx !== -1) {
                        locdistrict.text = locdistrict.text.substring(0,indx) + "...";
                    } else {
                        locdistrict.font.pixelSize -= 1;
                    }
                    fWideText = (locdistrict.paintedWidth >= parent.width - starimage.width - tText.width - 4*Util.forecastMargin);
                }
            //};
        }
    }

    MouseArea {
        hoverEnabled: true
        anchors.fill: parent
        onPressed: {
            if (!(locationspage.inputDialogVisible) && (location.id !== -1)) {
                //locList.currentIndex = index;
                //factory.currentLocation = index;
                mousePressed = true;
            }
        }
        onPressAndHold: {
            if (!(locationspage.inputDialogVisible) && (location.id !== -1)) {
                locList.currentIndex = index;
                factory.currentLocation = index;
                factory.showEditLocMenu();
                mousePressed = false;
                mouseTime = 0;
            }
        }
/*        onCanceled: {
            if (!(locationspage.inputDialogVisible) && (location.id !== -1) && containsMouse) {
                var pos = locList.contentY;
                var destPos;
                locationspage.clickY = parent.y + mouseY;
                //searchstring.text = location.prefName;
                inputDialog.message = location.prefName;
                if (mousePressed) {// && (mouseTime < 800)) {
                    mousePressed = false;
                    mouseTime = 0;
                    commonToolBar.tools = mainLayout;
                    pageStack.pop();
                };
            };
            //mousePressed = false;
            //mouseTime = 0;
        }
        onExited: {
            if (!(locationspage.inputDialogVisible) && (location.id !== -1) && containsMouse) {
                var pos = locList.contentY;
                var destPos;
                locationspage.clickY = parent.y + mouseY;
                //searchstring.text = location.prefName;
                inputDialog.message = location.prefName;
                if (mousePressed) {// && (mouseTime < 800)) {
                    mousePressed = false;
                    mouseTime = 0;
                    commonToolBar.tools = mainLayout;
                    pageStack.pop();
                };
            };
            //mousePressed = false;
            //mouseTime = 0;
        } */
        onReleased: {
            if (!(locationspage.inputDialogVisible) && (location.id !== -1)) {
                var pos = locList.contentY;
                var destPos;
                locationspage.clickY = parent.y + mouseY;
                //searchstring.text = location.prefName;
                inputDialog.message = location.prefName;
                if (mousePressed) {// && (mouseTime < 800)) {
                    locList.currentIndex = index;
                    factory.currentLocation = index;
                    mousePressed = false;
                    mouseTime = 0;
                    commonToolBar.tools = mainLayout;
                    if (forecast === undefined) {
                        factory.networkUpdate = true;
                        factory.isUpdatingNow = true;
                        factory.emitRefresh();
                    };
                    while (pageStack.depth > 1) pageStack.pop();
                };
            };
            //mousePressed = false;
            //mouseTime = 0;
        }
    }

    Image {
        id: starimage
        visible: location.id !== -1
        anchors.left: parent.left
        anchors.margins: Util.forecastMargin
        anchors.verticalCenter: parent.verticalCenter
        anchors.top: parent.top
        width: parent.height - 2*Util.forecastMargin
        height: parent.height - 2*Util.forecastMargin
        sourceSize.height: 240
        sourceSize.width: 240
        smooth: false
        source: (forecast === undefined) ? "" : "image://weather/" + forecast.iconDescription
    }

    Text {
        id: tText
        visible: location.id !== -1
        width: Util.temperatureWidth
        anchors.top: parent.top
        anchors.left: starimage.right
        anchors.leftMargin: Util.forecastMargin
        anchors.verticalCenter: parent.verticalCenter
        font.pixelSize: Util.dailyTfontSize
        horizontalAlignment: Text.AlignRight
        verticalAlignment: Text.AlignVCenter
        text: forecast.temperatureDescription(factory.t === 1)
        //color: (forecast.temperatureSign(factory.t === 1) === 1) ? "#FE9000" :
        //    ((forecast.temperatureSign(factory.t === 1) === -1) ? "#859CBA" : "#FFFFFF")
        color: "#FFFFFF"
        //text: forecast.temperatureDescription(true)
    }

    Text {
        id: locname
        visible: location.id !== -1
        anchors.top: parent.top
        anchors.topMargin: Util.forecastMargin
        anchors.left: tText.right
        anchors.leftMargin: Util.forecastMargin
        width: locList.width - 3*Util.forecastMargin - starimage.width - tText.width
        color: "#FFFFFF"
        font.pixelSize: Util.locationFontSize
        horizontalAlignment: Text.AlignLeft
        verticalAlignment: Text.AlignVCenter
        elide: Text.ElideRight
        text: location.prefName
    }

    Text {
        id: locdistrict
        visible: location.id !== -1
        anchors.top: locname.bottom
        anchors.left: tText.right
        anchors.leftMargin: Util.forecastMargin
        color: "#859CBA"
        font.pixelSize: Util.minfontSize - 2
        horizontalAlignment: Text.AlignLeft
        verticalAlignment: Text.AlignVCenter
        elide: Text.ElideRight
        text: (location.prefName === location.name) ? ((location.district === "") ? location.country : location.district) : location.name + ((location.district === "") ? ", " + location.country : ", " + location.district)
    }

    Text {
        id: loccountry
        visible: location.id !== -1
        anchors.top: locdistrict.bottom
        anchors.bottomMargin: Util.forecastMargin
        anchors.left: tText.right
        anchors.leftMargin: Util.forecastMargin
        color: "#859CBA"
        font.pixelSize: Util.minfontSize - 2
        horizontalAlignment: Text.AlignLeft
        verticalAlignment: Text.AlignVCenter
        elide: Text.ElideRight
        text: (location.district === "") ? "" : ((location.prefName === location.name) ? location.country : location.country)
    }

    Rectangle {
        id: down_line
        opacity: 0.5
        visible: location.id !== -1
        anchors.bottom: parent.bottom
        height: 1
        anchors.left: parent.left
        anchors.leftMargin: 0
        anchors.right: parent.right
        anchors.rightMargin: 0
        color: "#506B93"
    }

    Component.onCompleted: {
        locdistrict.font.pixelSize = Util.minfontSize - 2;
        var fWideText = (locdistrict.paintedWidth >= parent.width - starimage.width - tText.width - 4*Util.forecastMargin);
        while (fWideText) {
            var indx = locdistrict.text.lastIndexOf(" ");
            if (indx !== -1) {
                locdistrict.text = locdistrict.text.substring(0,indx) + "...";
            } else {
                locdistrict.font.pixelSize -= 1;
            }
            fWideText = (locdistrict.paintedWidth >= parent.width - starimage.width - tText.width - 4*Util.forecastMargin);
        };
        screenRotateTimer_loc.start();
    }
}
