import QtQuick 1.0
import Places 1.0
import "util.js" as Util
import com.nokia.meego 1.0

Page{
    id: locationspage
    //anchors.topMargin: Util.forecastMargin
    property int clickY: 0
    property int timeSinceMsgShown: 0

    function updateList() {
        locList.model.clear();
        console.log("locations count:");
        console.log(factory.locationsCount);
        factory.addEmptyLocation();
        for (var i=0; i<factory.locationsCount; i++) {
            var loc = factory.locations[i];
            var j=-1;
            var fFound = false;
            var iFact = 0;
            for (j=0; (j<loc.forecastsCount) && (!fFound); j++) {
                if (loc.forecasts[j].forecastType === Forecast.Fact) {
                    fFound = true;
                    iFact = j;
                    break;
                };
            }

            //if (fFound) {
                var fc = loc.forecasts[iFact];
                locList.model.append({"name": loc.prefName, "location": loc, "forecast": fc});
            //}
        };
        locList.currentIndex = factory.currentLocation;
        locList.visible = true;
        factory.removeEmptyLocation();
    }

    Timer {
        id: menuTimer
        interval: 100; running: true; triggeredOnStart: false; repeat: true;
        onTriggered: {
            if (timeSinceMsgShown > 0) {
                city.text = qsTr("list_not_empty");
                timeSinceMsgShown += 100;
                if (timeSinceMsgShown > 2050) {
                    timeSinceMsgShown = 0;
                    city.text = qsTr("Cities")
                }
            }
        }
    }

    Rectangle {
        //anchors.topMargin: st.height
        anchors.fill: parent

        Rectangle {

            id: locpageheader;
            z: 1
            anchors.left: parent.left;
            anchors.right: parent.right;
            anchors.top: parent.top;
            height: commonToolBar.height
            color: "#374A68"

            Image {
                id: header_bg;
                source: "qrc:/res/header_meego.png"
                anchors.left: parent.left;
                anchors.right: parent.right;
                anchors.top: parent.top;
                anchors.bottom: parent.bottom;
                //anchors.topMargin: -1
                anchors.leftMargin: -1
                anchors.rightMargin: -1
                sourceSize.width: 480
                sourceSize.height: 80
                smooth: true
            }

            ToolIcon {
                id: toolbutton1loc
                anchors.left: parent.left
                anchors.verticalCenter: parent.verticalCenter
                iconId: "toolbar-add"
                onClicked: {
                    pageStack.push(Qt.resolvedUrl("searchpage_meego.qml"))
                    commonToolBar.tools = backLayout;
                }
            }
/*
            ToolButton {
                id: toolbutton2loc
                text: qsTr("Edit")
                anchors.right: parent.right
                anchors.rightMargin: Util.marginDefault/2
                anchors.verticalCenter: parent.verticalCenter
                onClicked: {
                    if (locList.model.count > 0) {
                        if ((locList.currentIndex >= 0) && (locList.currentIndex < locList.model.count)) {
                            editMenu.open();
                        }
                    }
                }
            }
*/
            Text {
                id: city
                font.pixelSize: 30
                text: qsTr("Cities")
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignHCenter
                anchors.right: parent.right
                anchors.rightMargin: toolbutton1loc.width
                anchors.left: toolbutton1loc.right
                anchors.verticalCenter: parent.verticalCenter
                color: "white"
                font.weight: Font.Light
                elide: Text.ElideRight
                wrapMode: Text.NoWrap
            }

        }

        Rectangle {
            id: locListContainer
            anchors.right: parent.right
            anchors.left: parent.left
            anchors.bottom: parent.bottom
            anchors.top: locpageheader.bottom
            anchors.leftMargin: -1
            anchors.rightMargin: -1
            gradient: Gradient {
                GradientStop {
                    position: 0
                    color: "#374A68"
                }
                GradientStop {
                    position: 0.82
                    color: "#05080D"
                }
                GradientStop {
                    position: 1
                    color: "#05080D"
                }
            }
            ListView {
                id: locList
                anchors.fill: parent
                currentIndex: -1
                snapMode: ListView.SnapToItem
                orientation: ListView.Vertical
                highlightFollowsCurrentItem: true
                model: ListModel {
                    id: locListModel
                    ListElement {
                        name: ""
                        location: 0
                        forecast: 0
                    }
                }
                delegate: LocationsListDelegate_meego {id: locListDelegate}
                visible: false
            }
        }
    }

    Item {
        id: menuContainer
        anchors.bottom: parent.bottom
        height: (3*Util.minSize) / 8
        MenuMeego {
            id: editMenu
            anchors.bottom: locListContainer.bottom
            //anchors.bottomMargin: (factory.landscape) ? -commonToolBar.height : commonToolBar.height
            anchors.bottomMargin: commonToolBar.height
            height: 150
            content: MenuLayout {
                MenuItem {
                    text: qsTr("change_name")
                    onClicked: {
                        if (factory.locationsCount > 0) {
                            factory.BackButtonEnabled = false;
                            inputDialog.message = locList.model.get(locList.currentIndex).location.prefName;
                            inputDialog.open();
                        };
                        editMenu.close();
                    }
                }
                MenuItem {
                    text: qsTr("move_up")
                    onClicked: {
                        if ((factory.locationsCount > 0) && (locList.currentIndex > 0)) {
                            var ind = locList.currentIndex;
                            var i;
                            for (i=ind; i>0; i--) {
                                factory.swapLocations(i - 1, i);
                            };
                            updateList();
                            locList.currentIndex = 0;
                            factory.currentLocation = 0;
                            locList.positionViewAtIndex(0, ListView.Beginning);
                        }
                    }
                }
                MenuItem {
                    text: qsTr("delete")
                    onClicked: {
                        if (factory.locationsCount > 1) {
                            factory.BackButtonEnabled = false;
                            queryDeleteDlg.open();
                        } else {
                            timeSinceMsgShown = 50;
                            city.text = qsTr("list_not_empty");
                        };
                        editMenu.close();
                    }
                }
            }
        }
    }

    InputDialogMeego {
        id: inputDialog
        //y: (clickY + locpageheader.height + height + (3*commonToolBar.height)/2 > parent.height) ? parent.height - height - (3*commonToolBar.height)/2 : clickY + locpageheader.height - (3*commonToolBar.height)/2
        titleText: "Gismeteo"
        acceptButtonText: qsTr("OK")
        rejectButtonText: qsTr("Cancel")
        message: ""
        onAccepted: {
            if ((locList.currentIndex >= 0) && (locList.currentIndex < factory.locationsCount)) {
                factory.currentLocation = locList.currentIndex;
                if (message !== "") {
                    locList.model.get(locList.currentIndex).location.prefName = message;
                } else {
                    locList.model.get(locList.currentIndex).location.prefName = locList.model.get(locList.currentIndex).location.name;
                    message = locList.model.get(locList.currentIndex).location.name;
                };
                factory.updateLocationName(locList.model.get(locList.currentIndex).location.id, message);
                updateList();
                locList.currentIndex = factory.currentLocation;
                factory.BackButtonEnabled = true;
            }
        }
        onRejected: {
            factory.BackButtonEnabled = true;
        }
    }

    QueryDialog {
        id: queryDeleteDlg
        titleText: "Gismeteo"
        acceptButtonText: qsTr("Yes")
        rejectButtonText: qsTr("No")
        message: qsTr("query_delete")
        onAccepted: {
            var flag = factory.deleteLocationFromDB(locList.currentIndex);
            if (flag) {
                updateList();
                locList.currentIndex = factory.currentLocation;
            };
            factory.BackButtonEnabled = true;
        }
        onRejected: {
            factory.BackButtonEnabled = true;
        }
    }

    Connections {
        target: factory
        onUpdateLocationsSignal: {
            updateList();
            locList.currentIndex = factory.currentLocation;
        }
        onUpdateLocationsSignalForLocPage: {
            updateList();
            locList.currentIndex = factory.currentLocation;
        }
        onShowEditLocationMenu: {
            if (locList.model.count > 0) {
                if ((locList.currentIndex >= 0) && (locList.currentIndex < locList.model.count)) {
                    editMenu.open();
                }
            }
        }
    }
    //Component.onCompleted: {
    onStatusChanged: {
        if (status === PageStatus.Active) {
            console.log("*&^%$#@!")
            updateList();
        }
        if (status === PageStatus.Deactivating) {
            editMenu.close();
        }
    }

}
