import QtQuick 1.0
import Places 1.0
import "util.js" as Util
import com.nokia.meego 1.0
//import Qt.labs.components 1.0

Page {
    id: settingspage
    anchors.fill: parent

    Rectangle {
        id: optionspageheader;
        anchors.left: parent.left;
        anchors.right: parent.right;
        anchors.top: parent.top;
        height: commonToolBar.height
        color: "#374A68"
/*        gradient: Gradient {
            GradientStop {
                position: 0
                color: "#566886"
            }
            GradientStop {
                position: 0.4
                color: "#405268"
            }
            GradientStop {
                position: 1
                color: "#172744"
            }
        } */

        Image {
            id: header_bg;
            source: "qrc:/res/header_meego.png"
            anchors.left: parent.left;
            anchors.right: parent.right;
            anchors.top: parent.top;
            anchors.bottom: parent.bottom;
            anchors.leftMargin: -1
            anchors.rightMargin: -1
            sourceSize.width: 480
            sourceSize.height: 80
            smooth: false
        }

        Text {
            id: opt_title
            font.pixelSize: 32
            text: qsTr("Settings")
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter
            color: "white"
            font.weight: Font.Light
            elide: Text.ElideRight
            wrapMode: Text.NoWrap
        }
    }

    Rectangle {
        id: optionsRect
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: optionspageheader.bottom
        anchors.bottom: parent.bottom
        gradient: Gradient {
            GradientStop {
                position: 0
                color: "#374A68"
            }
            GradientStop {
                position: 0.82
                color: "#05080D"
            }
            GradientStop {
                position: 1
                color: "#05080D"
            }
        }
    }

    Image {
        id: banner
        smooth: true
        source: "qrc:/res/logo_meego.png"
        //anchors.verticalCenter: refresh.verticalCenter
        sourceSize.width: 126
        sourceSize.height: 38
        //height: Util.minfontSize*2
        //width: (height*sourceSize.width)/sourceSize.height
        width: sourceSize.width
        height: sourceSize.height
        anchors.right: parent.right
        anchors.rightMargin: Util.marginDefault
        anchors.bottom: parent.bottom
        anchors.bottomMargin: Util.forecastMargin + optionspageheader.height
    }

    Item {
        id: rbContainer
        width: (parent.height > parent.width) ? parent.width : parent.width/2
        height: 2*tmpText.height + 2*tempRow.height + 14*Util.forecastMargin
        //color: "#101620"
        anchors.top: optionspageheader.bottom
        anchors.leftMargin: (parent.height > parent.width) ? (3*Util.forecastMargin)/2 : (20*Util.forecastMargin)/6
        anchors.topMargin: (parent.height > parent.width) ? (3*Util.forecastMargin)/2 : Util.forecastMargin/2

        Text {
            id: tmpText
            font.pixelSize: 32
            text: qsTr("temperature")
            verticalAlignment: Text.AlignVCenter
            anchors.top: parent.top //banner.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.topMargin: Util.forecastMargin
            anchors.leftMargin: 2*Util.forecastMargin
            color: "white"
            font.weight: Font.Light
            elide: Text.ElideRight
            wrapMode: Text.NoWrap
        }

        Row {
            id: tempRow
            spacing: (9*parent.width)/20 - buttonC.width
            anchors.top: tmpText.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.leftMargin: 2*Util.forecastMargin
            anchors.topMargin: 2*Util.forecastMargin
            RadioButton {
                id: buttonC
                text: "°C"
                onClicked: {
                    if (checked) buttonF.checked = false;
                }
            }
            RadioButton {
                id: buttonF
                text: "°F"
                onClicked: {
                    if (checked) buttonC.checked = false;
                }
            }
        }

        Text {
            id: wsText
            font.pixelSize: 32
            text: qsTr("wind_speed")
            verticalAlignment: Text.AlignVCenter
            anchors.top: tempRow.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.leftMargin: 2*Util.forecastMargin
            anchors.topMargin: (10*Util.forecastMargin)/2
            color: "white"
            font.weight: Font.Light
            elide: Text.ElideRight
            wrapMode: Text.NoWrap
        }

        Row {
            id: wsRow
            spacing: (9*parent.width)/20 - buttonMpS.width
            anchors.top: wsText.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.leftMargin: 2*Util.forecastMargin
            anchors.topMargin: 2*Util.forecastMargin
            RadioButton {
                id: buttonMpS
                text: qsTr("mps")
                onClicked: {
                    if (checked) buttonKmH.checked = false;
                }
            }
            RadioButton {
                id: buttonKmH
                text: qsTr("kmh")
                onClicked: {
                    if (checked) buttonMpS.checked = false;
                }
            }
        }
    }

    Item {
        id: rbContainer2
        width: (parent.height > parent.width) ? parent.width : parent.width/2
        height: tmpText.height + tempRow.height + 3*Util.forecastMargin
        anchors.left: (parent.height > parent.width) ? parent.left : rbContainer.right
        //color: "#101620"
        anchors.top: (parent.height > parent.width) ? rbContainer.bottom : optionspageheader.bottom
        anchors.leftMargin: (3*Util.forecastMargin)/2
        anchors.topMargin: (parent.height > parent.width) ? (3*Util.forecastMargin)/2 : (3*Util.forecastMargin)/2


        Text {
            id: pressText
            font.pixelSize: 32
            text: qsTr("pressure")
            verticalAlignment: Text.AlignVCenter
            anchors.top: wsRow.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.leftMargin: Util.forecastMargin
            anchors.topMargin: (7*Util.forecastMargin)/2
            color: "white"
            font.weight: Font.Light
            elide: Text.ElideRight
            wrapMode: Text.NoWrap
        }

        Row {
            id: pressRow
            spacing: (9*parent.width)/20 - buttonMmHgSt.width
            anchors.top: pressText.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.leftMargin: Util.forecastMargin/2
            anchors.topMargin: 2*Util.forecastMargin
            RadioButton {
                id: buttonMmHgSt
                text: qsTr("mmhgst")
                onClicked: {
                    if (checked) buttongPa.checked = false;
                }
            }
            RadioButton {
                id: buttongPa
                text: qsTr("gPa")
                onClicked: {
                    if (checked) buttonMmHgSt.checked = false;
                }
            }
        }
    }
/*
    Item {
        id: optionButtonContainer
        width: (parent.height > parent.width) ? parent.width : parent.width/2
        height: languageChange.height + 2*Util.forecastMargin
        //color: "#101620"
        anchors.top: (parent.height > parent.width) ? rbContainer.bottom : banner.bottom
        anchors.left: (parent.height > parent.width) ? parent.left : rbContainer.right
        anchors.topMargin: 2*Util.forecastMargin

        Text {
            id: sourceText
            font.pixelSize: 24
            text: qsTr("source")
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
            anchors.top: pressRow.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.margins: Util.forecastMargin
            color: "white"
            font.weight: Font.Light
            elide: Text.ElideRight
            wrapMode: Text.NoWrap
        }

        Row {
            id: sourceRow
            spacing: platformStyle.paddingMedium
            anchors.top: sourceText.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.leftMargin: (parent.width - buttonWeb.width - buttonFile.width - Util.forecastMargin) / 2
            anchors.topMargin: Util.forecastMargin
            RadioButton {
                id: buttonWeb
                text: qsTr("server")
                onClicked: {
                    if (checked) buttonFile.checked = false;
                }
            }
            RadioButton {
                id: buttonFile
                text: qsTr("file")
                onClicked: {
                    if (checked) buttonWeb.checked = false;
                }
            }
        }
    }
*/
    Item {
        id: buttonContainer
        width: ((parent.height > parent.width) ? parent.width : parent.width/2) - 3*Util.forecastMargin
        height: languageChange.height + 2*Util.forecastMargin
        //color: "#101620"
        anchors.top: rbContainer2.bottom
        anchors.leftMargin: (3*Util.forecastMargin)/2
        anchors.topMargin: (parent.height > parent.width) ? (6*Util.forecastMargin)/2 : (37*Util.forecastMargin)/6
        //anchors.top: optionButtonContainer.bottom
        anchors.left: (parent.height > parent.width) ? parent.left : rbContainer.right

        ToolButton {
            id: languageChange
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.margins: Util.forecastMargin/2
            text: qsTr("language")
            onClicked: {
                languageMenu.visible = true;
                languageMenu.open();
            }
        }

        ToolButton {
            id: btnabout
            anchors.top: parent.top
            anchors.right: parent.right
            anchors.margins: Util.forecastMargin/2
            text: qsTr("about")
            onClicked: {
                pageStack.push(Qt.resolvedUrl("Aboutpage.qml"))
                commonToolBar.tools = backLayout;
            }
        }
    }

    Image {
        id: waitCursor
        smooth: true
        z: 1
        opacity: 0.66
        source: "qrc:/res/sand.png"
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.verticalCenter: parent.verticalCenter
        sourceSize.width: 48
        sourceSize.height: 48
        height: sourceSize.height
        width: sourceSize.width
        visible: false
    }

    MenuMeego {
        id: languageMenu
        anchors.bottom: parent.bottom
        anchors.bottomMargin: commonToolBar.height
        content: MenuLayout {
            MenuItem {
                text: "Русский"
                onClicked: {
                    if (factory.locale !== "ru") {
                        waitCursor.visible = true;
                    }
                    factory.updateLocale("ru");
                }
            }
            MenuItem {
                text: "English"
                onClicked: {
                    if (factory.locale !== "en") {
                        waitCursor.visible = true;
                    }
                    factory.updateLocale("en");
                }
            }
        }
    }

    Connections {
        target: factory
        onLanguageChangedSignal: {
            opt_title.text = qsTr("Settings");
            tmpText.text = qsTr("temperature");
            wsText.text = qsTr("wind_speed");
            buttonMpS.text = qsTr("mps");
            buttonKmH.text = qsTr("kmh");
            pressText.text = qsTr("pressure");
            buttonMmHgSt.text = qsTr("mmhgst");
            buttongPa.text = qsTr("gPa");
            //buttonWeb.text = qsTr("server");
            //buttonFile.text = qsTr("file");
            languageChange.text = qsTr("language");
            btnabout.text = qsTr("about");
        }
        onForecastsUpdated: {
            waitCursor.visible = false;
        }
        onConnectionError: {
            waitCursor.visible = false;
        }
    }

    onStatusChanged: {
        if (status === PageStatus.Active) {
            buttonC.checked = (factory.t === GismeteoFactory.Centigrade);
            buttonF.checked = (factory.t === GismeteoFactory.Fahrenheit);
            buttonMpS.checked = (factory.ws === GismeteoFactory.Mps);
            buttonKmH.checked = (factory.ws === GismeteoFactory.KmH);
            buttonMmHgSt.checked = (factory.p === GismeteoFactory.MmHgSt);
            buttongPa.checked = (factory.p == GismeteoFactory.GPa);
            //buttonWeb.checked = factory.GetForecastsFromNetwork;
            //buttonFile.checked = !(factory.GetForecastsFromNetwork);
        };
        if (status === PageStatus.Deactivating) {
            languageMenu.close();
            factory.t = (buttonC.checked) ? GismeteoFactory.Centigrade : GismeteoFactory.Fahrenheit;
            factory.ws = (buttonMpS.checked) ? GismeteoFactory.Mps : GismeteoFactory.KmH;
            factory.p = (buttonMmHgSt.checked) ? GismeteoFactory.MmHgSt : GismeteoFactory.GPa;
            factory.saveSettingsToDB();
            factory.updateOptions();
            //var flag = factory.GetForecastsFromNetwork;
            //factory.GetForecastsFromNetwork = (buttonWeb.checked);
            //if (buttonWeb.checked !== flag) {
            //    factory.parseLocationsFromNetwork();
            //}
        }
    }
}
